<?php
require_once('auth/Authorization.php');
$config = Op5Config::instance();
$groups = $config->getConfig('auth_groups');
//var_dump($groups);

$ldaprightsfile = '/opt/op5sys/etc/ldaprights.cfg';
if (!is_file($ldaprightsfile)) {
	exit(0);
}
if (!$ldaprights = file_get_contents($ldaprightsfile)) {
	exit("Could not read from " . $ldaprightsfile . ".\n");
} else if (strlen($ldaprights) < 1) {
	exit($ldaprightsfile . " is empty. \n");
}
//Split comments from permissions
$access_rights = explode('#', $ldaprights);
//Remove comments
$access_rights = $access_rights[count($access_rights)-1];
//Split permissions
$access_rights = explode("\n", $access_rights);

foreach ($access_rights as $key => $value) {
	if ($value === "\n" || strlen($value) < 1) {
		unset($access_rights[$key]);
	} else {
		//Explode on first whitespace char
		$value = explode(' ', $value, 2);
		$value[1] = trim($value[1]);
		//Explode groupnames
		$value[1] = explode(',', $value[1]);
		//Set permission per group,
		foreach ($value[1] as $groupkey => $groupname) {
			//Create array if it doesn't exist and avoid empty groupnames if grouplist ended in ,
			if (!isset($access_rights[$groupname]) && strlen($groupname) > 0) {
				$access_rights[$groupname] = array();
			}
			//Avoid empty groupnames if grouplist ended in ,
			if (strlen($groupname) > 0) {
				$access_rights[$groupname][] = $value[0];
			}
		}
		unset($access_rights[$key]);
	}
}
foreach ($access_rights as $groupname => $permissions) {
	//Translate nagios permissions to op5auth and add them to group.
	$groups[$groupname] = Op5Authorization::nagios_rights_to_op5auth($access_rights[$groupname]);
}

ksort($groups);
//Create a timestamped copy of the config
$now = time();
@exec('cp /etc/op5/auth_groups.yml /etc/op5/auth_groups_' . $now . '.yml');

//Write the new groupconfig
$config->setConfig('auth_groups', $groups);
