<?php

require_once('op5/config.php');

class Op5Livestatus {
	private static $instance = false;
	public static function instance() {
		$conf = Op5Config::instance()->getConfig('livestatus');
		if( $conf === false ) {
			return false;
		}
		return new self( $conf );
	}
	
	protected $config = false;

	public function __construct( $config ) {
		$this->config = $config;
		
	}
	
	/**
	 * Execute query, defined as string
	 * 
	 * @param unknown_type $query
	 */
	public function query( $query, $parameters=array(), $columns=false ) {
		$socket = fsockopen( "unix://".$this->config['path'], null, $errno, $errstr );
		if( !$socket ) {
			throw new Exception( "Livestatus: error opening socket: " . $errno . " - " . $errstr );
		}
		$parameters[] = "OutputFormat: json";
		if( is_array( $columns ) ) {
			$parameters[] = "Columns: " . implode( " ", $columns );
		}
		
		foreach( $parameters as $param ) {
			$query .= "\n" . $param;
		}
		$query .= "\n\n";

//		var_export( $query );
		fwrite( $socket, $query );
		$data = fread( $socket, 20480000 );
		$data .= fread( $socket, 20480000 );
		$data .= fread( $socket, 20480000 );
		fclose( $socket );

		
		$data = json_decode($data);
		
		if( !is_array( $columns ) ) {
			$columns = array_shift($data);
		}
		
		$result = array();
		foreach($data as $values) {
			$result[] = array_combine( $columns, $values );
		}
		return $result;
	}
}
